
#!/usr/bin/env python
from gimpfu import *
import random
from random import randint

def filling(inImage, inDrawable, inColourE, inColourS,
            inSearch, inMethod,
            inPalette, inGradient,
            workOnCopy) :

    pdb.gimp_context_push
    if workOnCopy==True:
        outImage = pdb.gimp_image_duplicate (inImage)
    else:
        outImage = inImage
    outDrawable = outImage.layers[0]
    currentFG = pdb.gimp_context_get_foreground()
    #pdb.gimp_message("Hello from my FILLING filter!")
    width = outImage.width
    height = outImage.height
    #pdb.gimp_message("Your input image dimensions are:  "
    #                 +"width="+str(width)+", height="+str(height))
    
    (Re, Ge, Be, Ae)=inColourE
    pdb.gimp_message("Your chosen colour to replace is:  "
                     +"R="+str(Re)+", G="+str(Ge)+", B="+str(Be)+", A="+str(Ae))
    
    
    n=0
    steps=max(1,int(width+height)/300)
    pdb.gimp_message("Step = "+str(steps))
    widthpoints=width/steps
    heightpoints=height/steps
    
    for w in range(widthpoints):  
      for h in range(heightpoints):
        
        if inSearch==0: # random
            x = randint(0,width-1)
            y = randint(0,height-1)
        
        if inSearch==1: # sequential
            x = w*steps
            y = h*steps
            
        #pdb.gimp_message("These cohordinates are:  "+"x="+str(x)+", y="+str(y))
    
        (R,G,B,A)=pdb.gimp_image_pick_color(outImage, outDrawable, x, y, False, False, 0)
        #pdb.gimp_message("Picked colour is:  "
        #             +"R="+str(R)+", G="+str(G)+", B="+str(B)+", A="+str(A))
    
        if (R==Re) and (G==Ge) and (B==Be):    
            pdb.gimp_image_select_contiguous_color(outImage, CHANNEL_OP_REPLACE, outDrawable, x, y)
            # recolouring according to user choice
            if inMethod==0: # random colours (light)
                Rr = randint(100,255)
                Gr = randint(100,255)
                Br = randint(100,255)
                Ar = 255
                #pdb.gimp_message("Generated colour is:  "
                #             +"Rr="+str(Rr)+", Gr="+str(Gr)+", Br="+str(Br)+", Ar="+str(Ar))

            if inMethod==1: # random colours from chosen palette
                LC=[]
                (numcolP, LC)=pdb.gimp_palette_get_colors(inPalette)
                Ic = randint(0,numcolP-1)
                (Rr,Gr,Br,Ar)=LC[Ic]
            if inMethod==2: # random colours from chosen gradient
                LC=[]
                (numcolP, LC)=pdb.gimp_gradient_get_uniform_samples(inGradient, 64, False)
                Ic = randint(0,63)
                Rr=LC[Ic+0]
                Gr=LC[Ic+1]
                Br=LC[Ic+2]
                Ar=LC[Ic+3]
            if inMethod==3: # random grays
                Rr = randint(0,255)
                Gr = Rr
                Br = Rr
                Ar = 255
            pdb.gimp_context_set_foreground((Rr,Gr,Br,Ar))  # set replacing colour
            pdb.gimp_edit_fill(outDrawable, FILL_FOREGROUND)
        
    '''
    # now fill all remaining areas by a fixed replacing colour
    pdb.gimp_image_select_color(outImage, CHANNEL_OP_REPLACE, outDrawable, inColourE)
    pdb.gimp_context_set_foreground(inColourS)  # set replacing colour
    pdb.gimp_edit_fill(outDrawable, FILL_FOREGROUND)
    '''
    
    pdb.gimp_selection_none(outImage)
    pdb.gimp_context_set_foreground(currentFG)
    pdb.gimp_context_pop
    
    if workOnCopy==True:
        pdb.gimp_display_new(outImage)

    return

# This is the plugin registration function
register(
    "filling",    
    "to fill with random colours a single colour area",   
    "This script examines randomly areas with a chosen colour and fill them with random colours.",
    "Diego", 
    "Diego Nassetti ", 
    "December 2015",
    "filling", 
    "RGB*", 
    [
      (PF_IMAGE, "image", "Input image", None),
      (PF_DRAWABLE, "drawable", "Input drawable", None),
      (PF_COLOR, "colore", "Colour to check and fill", (255, 255, 255, 255)),
      (PF_COLOR, "colorr", "Colour to replace residual areas (not active!)", (127, 127, 127, 255)),
      (PF_OPTION, "search", "Searching method", 1, ("random","sequential")),
      (PF_OPTION, "colours_source", "Colors replacing method", 0, ("random colours","random colours from chosen palette",
                                                                   "random colours from chosen gradient", "random grays")),
      (PF_PALETTE, "palette", "Palette name", "Pastels"),
      (PF_GRADIENT, "gradient", "Gradient name", "Tropical Colors"),
      (PF_TOGGLE, "usecopy", "Work on a copy", True)
    ], 
    [],
    filling,
    menu="<Image>/Diego/Render",
    )

main()
